# This is a simple setup script created to install my Gedit plugin
# because using distutils seemed like a lot of work!

print "starting..."
import sys

if len(sys.argv) < 2:
    print "usage: python setup.py install"
    print "use -system to install system wide (/usr/lib/gedit-2/plugins)"
    sys.exit()

missing = {}
if sys.argv[1] == 'install':
    try:
        print "testing bzr"
        import bzrlib
    except:
        missing['bzrlib'] = "Missing bzr."

    try:
        print "testing gtk"
        import gtk
    except:
        missing['gtk'] = "Missing pygtk."

    if len(missing) != 0:
        print "Can't install. Required files missing:"
        for miss in missing:
            print missing[miss]
    else:
        from os.path import exists, expanduser
        if sys.argv[2][0:10] == '-location=':
            destdir =  sys.argv[2][10:]
            if destdir[-1] != '/':
                destdir +="/"
            
        else:
            destdir = expanduser("~/.gnome2/gedit/plugins/")
        if not exists(destdir):
            from os import mkdir
            try:
                print "creating plugins directory %s" % destdir
                mkdir(destdir)
            except:
                print "Fatal error: Can't create %s\n%s" % (destdir,sys.exc_value)
        from shutil import copytree, copy
        from os import getcwd
        print "copying files to %s" % destdir
        try:
            copytree(getcwd()+"/plugins/bzr/",destdir+"bzr")
            copy(getcwd()+"/plugins/bzr.gedit-plugin",destdir)
        except:
            print "Error, can't copy: %s" % sys.exc_value
        else:
            print "Done!"
